VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsIShellFolder"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' Autor: F. Schler (frank@activevb.de)
' Datum: 11/2017
' enthlt nur die bentigten Funktionen

Option Explicit

Private Const ERR_BASE As Long = 40670
Private Const CLSID_ShellFolder As String = ""
    
Private Const IID_IShellFolder As String = _
    "{000214E6-0000-0000-C000-000000000046}"
    
Dim m_initialized As Boolean
Dim m_Interface As Interface_Data

Private Enum E_vtbOffsets
    vtb_QueryInterface
    vtb_AddRef
    vtb_Release
    vtb_ParseDisplayName
    vtb_EnumObjects
    vtb_BindToObject
    vtb_BindToStorage
    vtb_CompareIDs
    vtb_CreateViewObject
    vtb_GetAttributesOf
    vtb_GetUIObjectOf
    vtb_GetDisplayNameOf
    vtb_SetNameOf
End Enum

Public Function ParseDisplayName(ByVal pszDisplayName As String) As Long

    Dim lRet As Long
    Dim ppszDisplayName As Long
    Dim pchEaten As Long
    Dim ppchEaten As Long
    Dim ppidl As Long
    Dim pppidl As Long
    
    ppszDisplayName = StrPtr(pszDisplayName)
    ppchEaten = VarPtr(pchEaten)
    pppidl = VarPtr(ppidl)
    
    If x_OleInvoke(vtb_ParseDisplayName, 0&, 0&, ppszDisplayName, ppchEaten, pppidl, 0&) Then

        lRet = ppidl

    End If

    ParseDisplayName = lRet
    
End Function

Public Function BindToObject(ByVal pidl As Long, ByVal pbc As Long, ByVal riid As Long) As Long

    Dim lRet As Long
    Dim ppvOut As Long
    Dim pppvOut As Long

    pppvOut = VarPtr(ppvOut)

    If x_OleInvoke(vtb_BindToObject, pidl, pbc, riid, pppvOut) Then

        lRet = ppvOut

    End If

    BindToObject = lRet
    
End Function

Public Sub RaiseError(Optional ByVal Raise As Boolean = True)
    
    m_Interface.RaiseErrors = Raise
    
End Sub

Public Sub Initialize(Optional ByVal pInterface As Long = 0)

    m_Interface.owner = ObjPtr(Me)
    m_Interface.RaiseErrors = True

    If pInterface = 0 Then

        m_initialized = InitInterface(m_Interface, CLSID_ShellFolder, _
            IID_IShellFolder)
    
    Else
        
        m_Interface.ifc = pInterface
        m_initialized = True
    
    End If
End Sub

Private Sub Class_Terminate()

    ReleaseInterface m_Interface
    
End Sub

Private Function x_OleInvoke(vtb As E_vtbOffsets, ParamArray var()) As _
    Boolean
    
    Dim ret As Long
    
    If Not m_initialized Then
    
        InterfaceError m_Interface, ecd_OleInvoke
        
    Else
    
        x_OleInvoke = oleInvoke(m_Interface, vtb, ret, True, var)
        
    End If
    
End Function

Private Sub x_RaiseError()

    With m_Interface
    
        If .ecd Then Err.Raise ERR_BASE + .ecd, App.EXEName & _
            ".clsIShellFolder", .etx
            
        .ecd = 0
        .etx = ""
        
    End With
    
End Sub

