VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsMp3Info"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
' Autor: F. Schler (frank@activevb.de)
' Datum: 08/2018

Option Explicit

Private Const S_OK As Long = 0&
Private Const MAX_PATH As Long = 260&
Private Const IID_IShellFolder2 As String = "{93f2f68c-1d1b-11d3-a30e-00c04f79abd1}"

' SHELLDETAILS.str
Private Type strRet
    uType As Long
    cbStr(0 To MAX_PATH - 1) As Byte
End Type

' IShellFolder2.GetDetailsOf
Private Type SHELLDETAILS
    fmt As Long
    cxChar As Long
    str As strRet
End Type

' sIDs = "0,1,3,4,5,13,14,15,16,20,21,24,26,27,28"
Private Type ID3Tags
    FileName As String
    FileSize As String
    ChangeDate As String
    CreateDate As String
    LastAccessDate As String
    ContributingArtists As String
    Album As String
    Year As String
    Genre As String
    Artist As String
    Title As String
    Comment As String
    TrackNumber As String
    Duration As String
    Bitrate As String
End Type

' **************** Shell32.dll ****************
Private Declare Function SHGetDesktopFolder Lib "shell32" ( _
                         ByRef ppshf As Long) As Long

' **************** Shlwapi.dll ****************
Private Declare Function StrRetToStrA Lib "shlwapi" ( _
                         ByVal pStr As Long, _
                         ByVal pidl As Long, _
                         ByRef ppszName As Long) As Long

' **************** Ole32.dll ****************
Private Declare Function IIDFromString Lib "ole32" ( _
                         ByVal lpsz As Long, _
                         ByVal lpiid As Long) As Long

Private Declare Sub CoTaskMemFree Lib "ole32" ( _
                    ByVal pv As Long)

' **************** Oleaut32.dll ****************
Private Declare Function SysAllocString Lib "oleaut32" ( _
                         ByVal psz As Long) As String

Private aIDs() As String
Private tID3Tags As ID3Tags

Private Sub Class_Initialize()

    ' IDs der auszulesenden Felder
    ' 0 = Name
    ' 1 = Gre
    ' 2 = Elementtyp
    ' 3 = nderungsdatum
    ' 4 = Erstelldatum
    ' 5 = Letzter Zugriff
    ' 6 = Attribute
    ' 7 = Offlinestatus
    ' 8 = Offline verfgbar
    ' 9 = Erkannter Typ
    ' 10 = Besitzer
    ' 11 = Art
    ' 12 = Aufnahmedatum
    ' 13 = Mitwirkende Interpreten
    ' 14 = Album
    ' 15 = Jahr
    ' 16 = Genre
    ' 17 = Dirigenten
    ' 18 = Markierungen
    ' 19 = Bewertung
    ' 20 = Autoren/Interpret
    ' 21 = Titel
    ' 22 = Thema
    ' 23 = Kategorien
    ' 24 = Kommentare
    ' 25 = Copyright
    ' 26 = Titelnummer
    ' 27 = Lnge
    ' 28 = Bitrate
    ' 29 = Geschtzt/DRM
    ' Gibt noch weitere. Siehe Eigenschaften-Dialog einer MP3-Datei!

    Dim sIDs As String

    ' die fr uns interessanten IDs fr MP3
    sIDs = "0,1,3,4,5,13,14,15,16,20,21,24,26,27,28"

    ' IDs splitten
    aIDs = Split(sIDs, ",")

End Sub

Public Property Let Mp3File(ByVal sMp3Path As String)

    Call GetMp3Info(sMp3Path)

End Property

Public Property Get FileName() As String

    FileName = tID3Tags.FileName

End Property

Public Property Get FileSize() As String

    FileSize = tID3Tags.FileSize

End Property

Public Property Get ChangeDate() As String

    ChangeDate = tID3Tags.ChangeDate

End Property

Public Property Get CreateDate() As String

    CreateDate = tID3Tags.CreateDate

End Property

Public Property Get LastAccessDate() As String

    LastAccessDate = tID3Tags.LastAccessDate

End Property

Public Property Get ContributingArtists() As String

    ContributingArtists = tID3Tags.ContributingArtists

End Property

Public Property Get Album() As String

    Album = tID3Tags.Album

End Property

Public Property Get Year() As String

    Year = tID3Tags.Year

End Property

Public Property Get Genre() As String

    Genre = tID3Tags.Genre

End Property

Public Property Get Artist() As String

    Artist = tID3Tags.Artist

End Property

Public Property Get Title() As String

    Title = tID3Tags.Title

End Property

Public Property Get Comment() As String

    Comment = tID3Tags.Comment

End Property

Public Property Get TrackNumber() As String

    TrackNumber = tID3Tags.TrackNumber

End Property

Public Property Get Duration() As String

    Duration = tID3Tags.Duration

End Property

Public Property Get Bitrate() As String

    Bitrate = tID3Tags.Bitrate

End Property

Private Sub GetMp3Info(ByVal sMp3Path As String)

    Dim szName As String
    Dim szMp3File As String
    Dim szMp3Folder As String
    Dim lPIDL As Long
    Dim lPIDL2 As Long
    Dim lID As Long
    Dim lItem As Long
    Dim lCount As Long
    Dim pszName As Long
    Dim pIShellFolder As Long
    Dim pIShellFolder2 As Long
    Dim ptSHELLDETAILS As Long
    Dim ptSHELLDETAILS_str As Long
    Dim ptIID_IShellFolder2 As Long
    Dim psIID_IShellFolder2 As Long
    Dim tIID_IShellFolder2(3) As Long
    Dim tSHELLDETAILS As SHELLDETAILS
    Dim IShellFolder As clsIShellFolder
    Dim IShellFolder2 As clsIShellFolder2

    ' Pfad in Ordner und Datei aufteilen
    szMp3Folder = Left$(sMp3Path, InStrRev(sMp3Path, "\") - 1)
    szMp3File = Right$(sMp3Path, Len(sMp3Path) - InStrRev(sMp3Path, "\"))

    ' IShellFolder des Desktop ermitteln
    If SHGetDesktopFolder(pIShellFolder) = S_OK Then

        ' IShellFolder initialisieren
        Set IShellFolder = New clsIShellFolder
        Call IShellFolder.Initialize(pIShellFolder)
        Call IShellFolder.RaiseError(False)

        ' PIDL vom Ordner ermitteln
        lPIDL = IShellFolder.ParseDisplayName(szMp3Folder)

        ' ist eine PIDL vorhanden
        If lPIDL <> 0 Then

            ' IShellFolder2 -> tIID_IShellFolder2
            psIID_IShellFolder2 = StrPtr(IID_IShellFolder2)
            ptIID_IShellFolder2 = VarPtr(tIID_IShellFolder2(0))
            Call IIDFromString(psIID_IShellFolder2, ptIID_IShellFolder2)

            ' IShellFolder an IShellFolder2 binden
            pIShellFolder2 = IShellFolder.BindToObject(lPIDL, 0&, _
                ptIID_IShellFolder2)
                
            ' ist ein Pointer auf ein IShellFolder2-Interface vorhanden
            If pIShellFolder2 <> 0 Then

                ' IShellFolder2 initialisieren
                Set IShellFolder2 = New clsIShellFolder2
                Call IShellFolder2.Initialize(pIShellFolder2)
                Call IShellFolder2.RaiseError(False)

                ' PIDL von der Datei ermitteln
                lPIDL2 = IShellFolder2.ParseDisplayName(szMp3File)

                ' Pointer auf tSHELLDETAILS
                ptSHELLDETAILS = VarPtr(tSHELLDETAILS)

                ' Anzahl der auszulesenden IDs
                lCount = UBound(aIDs)

                ' IDs durchlaufen
                For lItem = 0 To lCount

                    ' String ID zu Long
                    lID = CLng(aIDs(lItem))

                    ' eine Eigenschaft abfragen
                    If IShellFolder2.GetDetailsOf(lPIDL2, lID, ptSHELLDETAILS) = _
                        True Then

                        ' Pointer auf tSHELLDETAILS.str
                        ptSHELLDETAILS_str = VarPtr(tSHELLDETAILS.str)

                        ' Stringpointer von PIDL zu Stringpointer
                        If StrRetToStrA(ptSHELLDETAILS_str, lPIDL2, pszName) = _
                            S_OK Then

                            ' Stringpointer zu String
                            szName = CutNull(SysAllocString(pszName))

                            ' nach ID selektieren
                            Select Case lID

                            Case 0
                                tID3Tags.FileName = szName

                            Case 1
                                tID3Tags.FileSize = szName

                            Case 3
                                tID3Tags.ChangeDate = szName

                            Case 4
                                tID3Tags.CreateDate = szName

                            Case 5
                                tID3Tags.LastAccessDate = szName

                            Case 13
                                tID3Tags.ContributingArtists = szName

                            Case 14
                                tID3Tags.Album = szName

                            Case 15
                                tID3Tags.Year = szName

                            Case 16
                                tID3Tags.Genre = szName

                            Case 20
                                tID3Tags.Artist = szName

                            Case 21
                                tID3Tags.Title = szName

                            Case 24
                                tID3Tags.Comment = szName
                            
                            Case 26
                                tID3Tags.TrackNumber = szName

                            Case 27
                                tID3Tags.Duration = szName

                            Case 28
                                tID3Tags.Bitrate = szName

                            End Select

                            ' aufrumen
                            Call CoTaskMemFree(pszName)

                        End If

                    End If

                Next

                ' aufrumen
                Call CoTaskMemFree(lPIDL2)

                ' aufrumen
                Set IShellFolder2 = Nothing

            End If

            ' aufrumen
            Call CoTaskMemFree(lPIDL)

        End If

        ' aufrumen
        Set IShellFolder = Nothing

    End If

End Sub

Private Function CutNull(ByVal sStr As String) As String

    If InStr(1, sStr, Chr$(0)) > 0 Then

        sStr = Mid$(sStr, 1, InStr(1, sStr, Chr$(0)) - 1)

    End If

    If InStr(1, sStr, Chr$(63)) > 0 Then

        sStr = Replace$(sStr, Chr$(63), vbNullString)

    End If

    CutNull = sStr

End Function

